package go_swagger

import (
	"os"
	"path/filepath"

	"github.com/juju/errors"

	"git.home.m-and-m.ovh/mderasse/gouick/helpers"

	log "github.com/sirupsen/logrus"
)

// deleteTempApiYaml will delete the temporary yaml api file generated by go-swagger.
func (a APIType) deleteTempApiYaml(path string) error {
	log.Debugf("Starting %s  - %s", a.GetName(), helpers.GetCurrentFuncName())

	tempFilePath := filepath.Join(path, mergeYamlFileName)

	// delete
	exist, err := helpers.FileExists(tempFilePath)
	if err != nil {
		return errors.Trace(err)
	}

	if !exist {
		log.Debug("File doesn't exist already")
		return nil
	}

	err = os.Remove(tempFilePath)
	if err != nil {
		log.Errorf("fail to delete file in %s", tempFilePath)
		return errors.Trace(err)
	}

	return nil
}
