package go_swagger

import (
	"path/filepath"

	"github.com/iancoleman/strcase"
	"github.com/juju/errors"

	"git.home.m-and-m.ovh/mderasse/gouick/helpers"
	"git.home.m-and-m.ovh/mderasse/gouick/models"

	log "github.com/sirupsen/logrus"
)

type makefileTemplate struct {
	AppNameKebabCase string
}

// generateMakefile will generate makefile based on the given config.
// Launched only at project init or on force.
func (a APIType) generateMakefile(path string, config *models.Config) error {
	log.Debugf("Starting %s - %s", a.GetName(), helpers.GetCurrentFuncName())

	templatePath := filepath.Join(templateDirectory, "Makefile.tmpl")
	savePath := filepath.Join(path, "Makefile")

	data := makefileTemplate{
		AppNameKebabCase: strcase.ToKebab(config.ProjectName),
	}

	err := helpers.WriteTemplate(templatePath, savePath, data)
	if err != nil {
		return errors.Trace(err)
	}

	return nil
}
