package go_swagger

import (
	"path/filepath"

	"github.com/juju/errors"

	"git.home.m-and-m.ovh/mderasse/gouick/helpers"
	"git.home.m-and-m.ovh/mderasse/gouick/models"

	log "github.com/sirupsen/logrus"
)

type readmeTemplate struct {
	ProjectDescription string
	ProjectName        string
}

// generateReadme will generate a readme based on the given config.
// Launched only at project init.
func (a APIType) generateReadme(path string, config *models.Config) error {
	log.Debugf("Starting %s - %s", a.GetName(), helpers.GetCurrentFuncName())

	templatePath := filepath.Join(templateDirectory, "Readme.md.tmpl")
	savePath := filepath.Join(path, "Readme.md")

	data := readmeTemplate{
		ProjectDescription: config.ProjectDescription,
		ProjectName:        config.ProjectName,
	}

	err := helpers.WriteTemplate(templatePath, savePath, data)
	if err != nil {
		return errors.Trace(err)
	}

	return nil
}
