package go_swagger

import (
	"os"
	"os/exec"

	"github.com/juju/errors"

	"git.home.m-and-m.ovh/mderasse/gouick/helpers"

	log "github.com/sirupsen/logrus"
)

// downloadGoDeps will execute go get ./... in the give repository.
func (a APIType) downloadGoDeps(path string) error {
	log.Debugf("Starting %s  - %s", a.GetName(), helpers.GetCurrentFuncName())

	// making sure that we are in the project directory
	if err := os.Chdir(path); err != nil {
		log.Error("Fail to move to the path")
		return errors.Trace(err)
	}

	// execute go get to download missing package
	cmd := exec.Command("go", "get", "./...")
	output, err := cmd.CombinedOutput()
	if err != nil {
		log.Error("fail to execute 'go get ./...'")
		return errors.Trace(err)
	}

	log.Debugf("'go get ./...' returned the following output: %s", string(output))

	return nil
}
